#ifndef _NSRDEBUG_ //-*-c++-*-
#define _NSRDEBUG_

//----------------------------------------------------------------------
//  nsrFILENAME.h
//   _TERSE_DESC_
//
//      Unpublished Confidential Information of Hewlett-Packard
//      Company. Do not disclose.  Copyright (c) Hewlett-Packard
//      Company 1995. All rights reserved
// 
// The contents of this software are proprietary and confidential to
// the Hewlett- Packard Company, and are limited in distribution to
// those with a direct need to know.  Individuals having access to
// this software are responsible for maintaining the confidentiality
// of the content and for keeping the software secure when not in use.
// Transfer to any party is strictly forbidden other than as expressly
// permitted in writing by Hewlett-Packard Company.  Unauthorized
// transfer to or possession by any unauthorized party may be a
// criminal offense.
//
//                  RESTRICTED RIGHTS LEGEND
//
//      Use,  duplication,  or disclosure by the U. S. Government is
//      subject to restrictions as set forth in subparagraph (c) (1)
//      (ii) in the Rights in Technical Data and Computer Software
//      clause in DFARS 252.227-7013 or any other successor clause.
//
//                      HEWLETT-PACKARD COMPANY
//                      3000 Hanover St.
//                      Palo Alto, CA  94304 U.S.A.
//
//      Rights for non-DOD U.S. Government Departments and Agencies
//      are as set forth in FAR 52.227-19 (c) (1,2) or any other
//      successor clause.
//
//  CLASSES:
//   Debug
//   ClassName2
//  
//----------------------------------------------------------------------
// $Source: /projects/HMS/nsr/udfCore/sys/nsrDebug.h,v $
// $Revision: 1.6 $     $Author: hmgr $
// $State: Exp $        $Locker:  $
// $Date: 96/05/21 15:09:54 $
//

class Debug {

    TagType          tagId;
    SearchDescriptor desc;

    Boolean          ISOVerify;
    ByteArray        ISOImage;

public:

    Debug(Boolean verify = True) ;
        
    Boolean verifyISO()     const { return ISOVerify; }
    void enableVerifyISO()  { ISOVerify = True; }
    void disableVerifyISO() { ISOVerify = False; }

    Error error() const { return ISOImage.error(); }

    void holdImage( BYTE_PTR rbp, UINT16 len );
    BYTE_PTR image()  { return (BYTE_PTR)ISOImage; }
    UINT32 imageLen() const { return ISOImage.length(); }

};

static Debug debug;      // static data member of NSR::

#endif




